<!--  order 订单 -->
<template>
  <div>
    <div class="mb10">
      <el-input clearable class="w250 mr20" v-model="search_data.search" placeholder="搜索"></el-input>
      <!-- <el-select clearable class="mr20 w200" clearable v-model="search_data.type" placeholder="请选择类型">
        <el-option label="请选择类型" value></el-option>
        <el-option v-for="item in  GetBaseData('orders','type')" :key="item.id" :label="item.name" :value="item.id"></el-option>
      </el-select> -->

      <el-select clearable class="mr20 w200" v-model="search_data.refunding" placeholder="维权状态">
        <el-option label="请选择维权状态" value></el-option>
        <el-option  label="存在维权信息" value="1"></el-option>
         <el-option  label="无维权信息" value="2"></el-option>
      </el-select>

      <zw-select class="mr20 w120" placeholder="全部" v-model="search_data.filter_goods_owner" :List="locBaseData.filterGoodsByCreator" />


      <el-input clearable class="w250 mr20" v-model="search_data.p" placeholder="商品名 - 用于团购 - 可以放编号好找"></el-input>

    
    </div>

    <div class="mb10">
        <el-date-picker value-format="yyyy-MM-dd" v-model="search_data.start_end" type="daterange" range-separator="至" start-placeholder="开始日期" end-placeholder="结束日期">
      </el-date-picker>

      <el-button class="ml10" icon="el-icon-search" size="small" type="primary" @click="m_search">搜索</el-button>
      <el-button size="small" type="danger" @click="handle_close_order">批量关闭</el-button>
       <el-button size="small" type="primary"  @click="upload">导出</el-button>
       <el-button size="small" type="primary"  @click="excelPending">待处理的CSV</el-button>
       <el-button size="small" type="primary"  @click="$refs.file.click()">导入Csv</el-button>
       <input  type="file" name="file" style="display:none" ref="file" @change="uploadCsv($event)" > 
    </div>

    <el-tabs v-model="search_data.status" @tab-click="handleClick">
      <el-tab-pane label="全部" name="-10"></el-tab-pane>
      <el-tab-pane v-for="item in  GetBaseData('orders','status')" :key="item.id" :label="item.name" :name="item.id+''"></el-tab-pane>
    </el-tabs>

    <el-table ref="m_table" size="mini" border :max-height="tableHeight" v-loading="m_tableLoading" @selection-change="m_handleSelectionChange" @current-change="m_handleCurrentChange" border :stripe="true" tooltip-effect="dark" :highlight-current-row="true" :data="m_list">
      <el-table-column align="center" type="selection" width="55"></el-table-column>
        <el-table-column  align="center" type="index"  width="50"></el-table-column>
      <el-table-column align="center" width="200" prop="order_no" label="订单号"></el-table-column>
      <el-table-column align="center" prop="name" width="150" label="账号"></el-table-column>
      
      <el-table-column align="center" prop="type" label="类型" width="100">
        <template slot-scope="scope"><span>{{scope.row.type | BaseData('orders','type')}}</span> </template>
      </el-table-column>

      <el-table-column align="center" prop="status" label="状态" width="100">
        <template slot-scope="scope"><span :class="scope.row.status|order_status_class">{{scope.row.status | BaseData('orders','status')}}</span> </template>
      </el-table-column>
      <el-table-column :show-overflow-tooltip="true" align="center" prop="item_title" label="商品">
        <template slot-scope="scope">
          <div v-for="item in scope.row.order_goods" :key="item.id" class="flex flex-m mb5">
            <img class="tb-img " :src="item.images" alt="">
            <div class="ml10">
              <p class="tb-title">{{item.title}}</p>
              <div class="tb-price">{{item.price}}元 X {{item.num}}</div>
            </div>
          </div>
        </template>
      </el-table-column>
      <el-table-column width="110" align="center" prop="goods_amount" label="商品总额(元)"></el-table-column>
      <el-table-column width="80" align="center" prop="express_amount" label="运费(元)"></el-table-column>
      <el-table-column width="110" align="center" prop="total_amount" label="订单总额(元)"></el-table-column>
      <el-table-column width="150" align="center" prop="created_at" label="创建时间"></el-table-column>
      <el-table-column align="center" label="操作" width="160px" fixed="right">
        <template slot-scope="scope">
          <el-button size="mini" v-if="scope.row.refund_id!=0" @click.native="hadel_refund(scope.row)" type="text">维权信息</el-button>
          <el-button size="mini" @click.native="hadel_detail(scope.row)" type="text">详情</el-button>
          <el-button size="mini" v-if="scope.row.status==0" @click.native="handle_close_order(scope.row)" type="text"><span class="m_red">关闭订单</span></el-button>
        </template>
      </el-table-column>

    </el-table>
    <refund  :id="refund_id" v-model="refund_show" v-if="refund_show"  />
    <detail @save-after="getDatalist" :id="id" :order_info="order_info" v-model="detailShow" v-if="detailShow" />
    <Paging class="mt20 mb30" :pageIndex="m_page.page" :pageSize="m_page.limit" :pageTotal="m_page.total" @changeSize="m_changesize" @changeIndex="m_changeindex"></Paging>
    <ZmEnclosure  ref="ZmEnclosure"/>
  </div>
</template>

<script>
import detail from './detail'
import * as api from '@/api'
import refund from './refund'
import ZmEnclosure from '@/components/downloadFile/index'
export default {
  name: 'order',
  components: { detail ,refund , ZmEnclosure },
  props:{
   type:{
     type:String
   }
  },
  data() {
    return {
      search_data: {
        status: '-10',
        search: '',
        start_end: [],
        refunding:'',
        type:'0',
        p: '',
        filter_goods_owner: '',
      },
      downLoading:false,
      detailShow: false,
      id: '',
      order_info:{},
      refund_show:false,
      refund_id:'',
      csv: '', 
    }
  },
  created() {
    this.init()
  },
  methods: {
    //初始化方法
    init() {
      if(this.type){
        this.search_data.type = this.type
      }
      this.getDatalist()
    },

    //获取数据信息
    getDatalist() {
      this.m_tableLoading = true
      let data = { ...this.search_data, ...this.m_page }
      if (data.status == -10) {
        data.status = ''
      }

      api.orders(data).then(res => {
        //console.log(res)
        this.m_list = res.data.data
        this.m_page.total = res.data.total

      }).finally(() => {
        this.m_tableLoading = false
      })
    },

    handle_close_order(row) {
      this.$confirm(`是否确定关闭选中订单?`, '提示', {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        this.close_order(row.id)
      }).catch(() => {
        //取消删除
      })
    },

    //删除
    close_order(id) {
      let m_delId = id ? [id] : this.m_delId
      this.m_loading = true
      api.order_close({ id: m_delId }).then(res => {
        // 删除成功
        this.m_loading = false
        this.m_success('关闭成功')
        this.getDatalist()
      }).catch(res => {
        this.m_loading = false
      })
    },

    //详情
    hadel_detail(row) {
      this.id = row.id
      this.$nextTick(() => {
        this.detailShow = true
      })

    },

    handleClick(v) {
      this.getDatalist()
    },

    hadel_refund(row){
      this.order_info = {...row}
       this.refund_id = row.refund_id
       this.refund_show = true
    },
     //导出
    upload() {
      let data = { ...this.search_data, ...this.m_page }
      if (data.status == -10) {
        data.status = ''
      }
    
     this.$refs.ZmEnclosure.toDownload(data,'/order/excel','订单导出')
    },

    excelPending() { 
      this.search_data.status = 1 

      let data = { ...this.search_data, ...this.m_page }
      if (data.status == -10) {
        data.status = ''
      }
    
     this.$refs.ZmEnclosure.toDownload(data,'/order/excel/pending','订单导出')
    }, 
    uploadCsv(event) { 
      // assign csv to upload 
      this.m_loading = true
      let data = new FormData() ;
      data.append('file', event.target.files[0])

      api.upload_csv(data).then( res => { 
        this.m_loading = false
        this.m_success('导入成功')
      }).catch(res => {
        this.m_loading = false
         this.m_error('导入失败')
      })
    }
  },
}

</script>
<style lang='scss' scoped>
.tb-img {
  width: 50px;
  height: 50px;
  flex-shrink: 0
}
.tb-title {
  word-wrap: break-all;
}

.tb-price {
  font-weight: bold;
  text-align: left !important;
}
</style>